{% load static %}

{% include 'sub_templates/base.html' %}
{{'menu.scss'|css_compiler|safe}}
{{'reportes.scss'|css_compiler|safe}}

<head>
  <title>Seleccionar documentacion</title>

  <script type="text/javascript">
    function toggle_checkbox(checkbox){
      checkbox = $(checkbox)
      let current_check = checkbox.prop("checked");

      checkbox.prop("checked", !current_check);
    }

    function select_test(elem){
      let checkbox = $(elem).children('.input-group-prepend').children().children();
      toggle_checkbox(checkbox);
    }

    function select_childrens(elem){
      let current_check = $(elem).prop("checked");

      $(elem.parentNode.parentNode.parentNode.parentNode).children('.sub-menu-items').children('.children').each((i, children_elem)=>{
        checkbox = children_elem.children[0].children[0].children[0].children;

        $(checkbox).prop("checked", current_check);
        if ($(children_elem).children('.level').hasClass('sub-menu')){
          select_childrens(checkbox[0]);
        }
      })
    }

    function check_father(elem){
      let brothers = $(elem.parentNode.parentNode.parentNode.parentNode.parentNode).children()

      if ($(elem).hasClass('test')){
        brothers = $(elem.parentNode.parentNode).children()
      }

      let all_checked = true;

      brothers.each((i, child)=>{
        if (!$(child).children('.input-group').children('.input-group-prepend').children().children('input').prop('checked')){
          all_checked = false;
        }
      })

      let change = false
      parent_checkbox = brothers.parent().parent().children('.input-group').children('.input-group-prepend').children().children('input');
      if (all_checked){
        change = parent_checkbox.prop('checked') == false
        parent_checkbox.prop('checked', true)
      }
      else {
        change = parent_checkbox.prop('checked') == true
        parent_checkbox.prop('checked', false)
      }

      if (change){
        check_father(parent_checkbox[0])
      }
    }

  </script>
</head>

<body>
  <div class="title">
    <h1 class="text-center">Seleccionar las pruebas a documentar</h1>
  </div>
  <div class="position-absolute ml-4 mt-3" style="width: 2.6rem;">
    <a href="{{back}}">{{'arrow-left-solid.svg'|svgColor:'var(--light)'|safe}}</a>
  </div>
  <form class="content centerX" method="POST" action="/{{project_id}}/reportes_generados">
    {% csrf_token %}
    <div class="center-section">
      {% for test_types in tests %}
      <div class="children">
        <div class="input-group level test-types sub-menu">
          <div class="input-group-prepend">
            <div class="input-group-text">
              <input type="checkbox" onchange="select_childrens(this);">
            </div>
          </div>
          <label type="text" class="form-control" onclick="toggle_chevron(this);" data-toggle="collapse" href="#{{test_types.value}}" aria-expanded="true"> {{test_types.name}} 
            {{'down'|chevron:'var(--secondary)'|safe}}
          </label>
        </div>
        <div class="sub-menu-items content-test-type collapse show" id='{{test_types.value}}'>
          {% for test_type in test_types.childrens %}
          <div class="children">
            <div class="input-group level test-type sub-menu">
              <div class="input-group-prepend">
                <div class="input-group-text">
                  <input type="checkbox" onchange="select_childrens(this); check_father(this);">
                </div>
              </div>
              <label type="text" class="form-control" onclick="toggle_chevron(this);" data-toggle="collapse" href="#{{test_types.value}}_{{test_type.value}}" aria-expanded="true"> {{test_type.name}}
                {{'down'|chevron:'var(--secondary)'|safe}}
              </label>
            </div>
            <div class="sub-menu-items sections collapse show" id='{{test_types.value}}_{{test_type.value}}'>
              {% for section in test_type.childrens %}
              <div class="children">
                <div class="input-group level section sub-menu">
                  <div class="input-group-prepend">
                    <div class="input-group-text">
                      <input type="checkbox" onchange="select_childrens(this); check_father(this);">
                    </div>
                  </div>
                  <label type="text" class="form-control" onclick="toggle_chevron(this);" data-toggle="collapse" href="#{{test_types.value}}_{{test_type.value}}_{{section.value}}" aria-expanded="true"> {{section.name}} 
                    {{'down'|chevron:'var(--secondary)'|safe}}
                  </label>
                </div>
                <div class="sub-menu-items tests collapse show" id='{{test_types.value}}_{{test_type.value}}_{{section.value}}'>
                  {% for test in section.childrens %}
                  <div class="children">
                    <div class="input-group level test" onclick="select_test(this); check_father(this);">
                      <div class="input-group-prepend">
                        <div class="input-group-text">
                          <input type="checkbox" onclick="toggle_checkbox(this);" name="{{test_type.value}}__{{test.id}}">
                        </div>
                      </div>
                      <label type="text" class="form-control"> {{test.title|replace_env_vars:project_id}} </label>
                    </div>
                  </div>
                  {% endfor %}
                </div>
              </div>
              {% endfor %}
            </div>
          </div>
          {% endfor %}
        </div>
      </div>
      {% endfor %}
    </div>

    <div class="right-section">
      <div class="documentation-type">
        <div class="input-group" onclick="select_test(this);">
          <div class="input-group-prepend">
            <div class="input-group-text">
              <input type="checkbox" onclick="toggle_checkbox(this);" name="show_detail" checked>
            </div>
          </div>
          <label type="text" class="form-control"> Mostrar detalle de las pruebas </label>
        </div>
        <div class="input-group" onclick="select_test(this);">
          <div class="input-group-prepend">
            <div class="input-group-text">
              <input type="checkbox" onclick="toggle_checkbox(this);" name="show_results" checked>
            </div>
          </div>
          <label type="text" class="form-control"> Mostrar resultados de ejecuciones </label>
        </div>
      </div>
      <button id="generate" type="submit" class="btn btn-info centerX"> Generar Documentación </button>
    </div>
  </form>
</body>